#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>

FILE* ftlk = NULL;
FILE* ftxt = NULL;
unsigned short* offsets = NULL;

bool label1;
bool label2;
bool label3;
bool label4;
bool label5;
bool label6;
bool label7;
bool label8;
bool label9;
bool label10;
int writegold;
bool change;

bool defaultanswer;

void writenewline()
{
	char strnum[8];

	sprintf(strnum, "\r\n");
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
}

void writebreak(bool includenewline = true)
{
	char strnum[128];

	sprintf(strnum, "---------------------------------------------------------------------");
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
	if(true == includenewline)
	{
		writenewline();
	}
}

unsigned short processnumentries()
{
	unsigned short numentries;
	char strnum[128];

	fread(&numentries, sizeof(unsigned short), 1, ftlk);
	sprintf(strnum, "Number of entries: %d", numentries);
	fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
	writenewline();
	writenewline();
	writenewline();

	return numentries;
}

void processheaders(unsigned short numentries)
{
	int index;
	unsigned short npcnum;
	unsigned short scriptoffset;
	char strnum[128];

	offsets = (unsigned short*)malloc(sizeof(unsigned short) * numentries);
	for(index = 0; index < numentries; index++)
	{
		fread(&npcnum, sizeof(unsigned short), 1, ftlk);
		fread(&scriptoffset, sizeof(unsigned short), 1, ftlk);
		offsets[index] = scriptoffset;

		sprintf(strnum, "NPC Number: %d", npcnum);
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		sprintf(strnum, "Script Offset: %d", scriptoffset);
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		writenewline();
		writenewline();
	}

	writenewline();
}

bool iskeyword = false;

bool processchar(unsigned char c)
{
	static bool wasphrase = false;
	bool realphrase = false;
	bool phrase = false;
	char strnum[128];

	if((c >= 165) && (c <= 218))
	{
		c -= 128;
	}
	else if((c >= 225) && (c <= 250))
	{
		c -= 128;
	}
	else if((c >= 160) && (c <= 161))
	{
		c -= 128;
	}
	else
	{
		phrase = true;
	}

	if(false == phrase)
	{
		if('@' == c)
		{
			writenewline();
			return false;
		}

		fputc(c,ftxt);
		wasphrase = false;
	}
	else
	{
		if((1 <= c) && (7 >= c))
		{
			const char* compressedwords[] = {"the", "thou", "of", "to", "and", "that", "for"};
			sprintf(strnum, "%s", compressedwords[c - 1]);
			realphrase = true;
		}
		else if((9 <= c) && (27 >= c))
		{
			const char* compressedwords[] = {"in", "is", "have", "with", "you", "this", "not",
				"my", "it", "me", "but", "dost", "know", "be", "was", "Blackthorn", "from",
				"thy", "one"};
			sprintf(strnum, "%s", compressedwords[c - 9]);
			realphrase = true;
		}
		else if((29 <= c) && (49 >= c))
		{
			const char* compressedwords[] = {"are", "here", "many", "Lord", "am", "we", "they",
				"he", "would", "art", "on", "young", "what", "see", "like", "only", "by",
				"there", "Blackthorn's", "good", "been"};
			sprintf(strnum, "%s", compressedwords[c - 29]);
			realphrase = true;
		}
		else if((51 <= c) && (64 >= c))
		{
			const char* compressedwords[] = {"must", "his", "British", "fine", "an",
				"great", "thee", "our", "who", "name", "heard", "as", "at", "has"};
			sprintf(strnum, "%s", compressedwords[c - 51]);
			realphrase = true;
		}
		else if(66 == c)
		{
			sprintf(strnum, "%s", "through");
			realphrase = true;
		}
		else if((68 <= c) && (69 >= c))
		{
			const char* compressedwords[] = {"once", "can"};
			sprintf(strnum, "%s", compressedwords[c - 68]);
			realphrase = true;
		}
		else if(71 == c)
		{
			sprintf(strnum, "%s", "him");
			realphrase = true;
		}
		else if((76 <= c) && (129 >= c))
		{
			const char* compressedwords[] = {"ye", "Shadowlords", "tell", "some", "believe",
				"all", "their", "upon", "even", "'tis", "find", "if", "about", "don't",
				"before", "those", "just", "make", "will", "when", "three", "Great", "might",
				"those", "old", "hast", "ask", "unto", "wish", "man", "so", "knows",
				"still", "Mantra", "out", "help", "well", "shall", "think", "where", "named",
				"talking", "more", "such", "very", "many", "lives", "canst", "which", "since",
				"need", "I've", "work", "<insert Avatar's name here>"};
			sprintf(strnum, "%s", compressedwords[c - 76]);
			realphrase = true;
		}
		else
		{
			switch(c)
			{
			case 130:
				sprintf(strnum, "<End Conversation>");
				break;
			case 131:
				sprintf(strnum, "<Pause>");
				break;
			case 132:
				sprintf(strnum, "<Join Party>");
				break;
			case 133:
				sprintf(strnum, "<Gold - ");
				writegold = 0;
				break;
			case 134:
				sprintf(strnum, "<Change>");
				change = true;
				break;
			case 135:
				sprintf(strnum, "<Or>");
				break;
			case 136:
				sprintf(strnum, "<Ask Name>");
				break;
			case 137:
				sprintf(strnum, "<Karma + 1>");
				break;
			case 138:
				sprintf(strnum, "<Karma - 1>");
				break;
			case 139:
				sprintf(strnum, "<Call Guards>");
				break;
			case 140:
				sprintf(strnum, "<Set Flag>");
				break;
			case 141:
				sprintf(strnum, "<New Line>");
				break;
			case 142:
				sprintf(strnum, "<Rune>");
				break;
			case 143:
				sprintf(strnum, "<Key Wait>");
				break;
			case 144:
				defaultanswer = true;
				return true;
				break;
			case 145:
				if(false == label1)
				{
					sprintf(strnum, "<Goto Label 1>");
					label1 = true;
				}
				else
				{
					sprintf(strnum, "<Label 1>");
				}
				break;
			case 146:
				if(false == label2)
				{
					sprintf(strnum, "<Goto Label 2>");
					label2 = true;
				}
				else
				{
					sprintf(strnum, "<Label 2>");
				}
				break;
			case 147:
				if(false == label3)
				{
					sprintf(strnum, "<Goto Label 3>");
					label3 = true;
				}
				else
				{
					sprintf(strnum, "<Label 3>");
				}
				break;
			case 148:
				if(false == label4)
				{
					sprintf(strnum, "<Goto Label 4>");
					label4 = true;
				}
				else
				{
					sprintf(strnum, "<Label 4>");
				}
				break;
			case 149:
				if(false == label5)
				{
					sprintf(strnum, "<Goto Label 5>");
					label4 = true;
				}
				else
				{
					sprintf(strnum, "<Label 5>");
				}
				break;
			case 150:
				if(false == label5)
				{
					sprintf(strnum, "<Goto Label 5>");
					label5 = true;
				}
				else
				{
					sprintf(strnum, "<Label 5>");
				}
				break;
			case 151:
				if(false == label6)
				{
					sprintf(strnum, "<Goto Label 6>");
					label6 = true;
				}
				else
				{
					sprintf(strnum, "<Label 6>");
				}
				break;
			case 152:
				if(false == label7)
				{
					sprintf(strnum, "<Goto Label 7>");
					label7 = true;
				}
				else
				{
					sprintf(strnum, "<Label 7>");
				}
				break;
			case 153:
				if(false == label8)
				{
					sprintf(strnum, "<Goto Label 8>");
					label8 = true;
				}
				else
				{
					sprintf(strnum, "<Label 8>");
				}
				break;
			case 154:
				if(false == label9)
				{
					sprintf(strnum, "<Goto Label 9>");
					label9 = true;
				}
				else
				{
					sprintf(strnum, "<Label 9>");
				}
				break;
			case 155:
				if(false == label10)
				{
					sprintf(strnum, "<Goto Label 10>");
					label10 = true;
				}
				else
				{
					sprintf(strnum, "<Label 10>");
				}
				break;
			default:
				if((162 == c) || (159 == c) || (255 == c))
				{
					// Not entirely sure.  Think 162 signifies code, and 159 signifies enter
					// No clue what 255 is
					return true;
				}
				else
				{
					sprintf(strnum, "<Unknown: %d>", c);
				}
				break;
			}
		}
		if((false == wasphrase) && (true == realphrase))
		{
			fputc(' ', ftxt);
		}
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		if(true == realphrase)
		{
			fputc(' ', ftxt);
			wasphrase = true;
		}
	}

	return true;
}

bool processentrynum(int entrynum)
{
	char strnum[128];
	switch(entrynum)
	{
	case 1:
		sprintf(strnum, "Name: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		return true;
	case 2:
		sprintf(strnum, "Description: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		return true;
	case 3:
		sprintf(strnum, "Greeting: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		return true;
	case 4:
		sprintf(strnum, "Job: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		return true;
	case 5:
		sprintf(strnum, "Bye: ");
		fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		return true;
	default:
		return false;
	}
}

void processspeech()
{
	unsigned char curchar;
	char speechstr[512];
	char strnum[128];
	bool entrytype;

	bool charreturnval;

	writebreak();
	int entrynum = 0;

	strnum[0] = 0;
	
	label1 = false;
	label2 = false;
	label3 = false;
	label4 = false;
	label5 = false;
	label6 = false;
	label7 = false;
	label8 = false;
	label9 = false;
	label10 = false;
	change = false;
	writegold = 5;

	while(1)
	{
		if(feof(ftlk))
		{
			break;
		}

		memset(speechstr, 0, 512);
		entrynum++;
		for(unsigned int index = 0; index < 511; index++)
		{
			curchar = fgetc(ftlk);
			if(feof(ftlk))
			{
				break;
			}
			if(0 == curchar)
			{
				break;
			}
			speechstr[index] = curchar;
		}

		entrytype = processentrynum(entrynum);
		

		defaultanswer = false;

		for(unsigned int index = 0; index < strlen(speechstr); index++)
		{
			curchar = speechstr[index];
			charreturnval = processchar(curchar);
			if(change == true)
			{
				curchar = speechstr[index + 1];
				sprintf(strnum, "<Item: %d>", curchar);
				fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
				index++;
				change = false;
			}
			if(4 > writegold)
			{
				writegold++;
			}
			if( 4 == writegold)
			{
				fputc('>', ftxt);
				writegold++;
			}
			if(!charreturnval)
			{
				if(true == defaultanswer)
				{
					sprintf(strnum, "<Any>");
					fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
					writenewline();
				}
				return;
			}
		}

		if(true == defaultanswer)
		{
			writenewline();
			sprintf(strnum, "<Any>");
			fwrite(strnum, sizeof(char), strlen(strnum), ftxt);
		}
		writenewline();
	}
}

void processdecode()
{
	unsigned short numentries;

	numentries = processnumentries();
	processheaders(numentries);

	for(unsigned short index = 0; index < numentries; index++)
	{
		fseek(ftlk, offsets[index], SEEK_SET);
		processspeech();
	}
	writebreak(false);
}

void decodefile(const char* filename)
{
	char tlkfile[16];
	char txtfile[16];

	sprintf(tlkfile, "%s.tlk", filename);
	sprintf(txtfile, "%s.txt", filename);

	if((ftlk = fopen(tlkfile, "rb") ) == NULL)
	{
		return;
	}

	if((ftxt = fopen(txtfile, "wb") ) == NULL)
	{
		fclose(ftlk);
		return;
	}

	processdecode();

	if(NULL != offsets)
	{
		free(offsets);
		offsets = NULL;
	}

	fclose(ftlk);
	fclose(ftxt);
}

int main()
{
	int done = 0;
	int index;
	int numFiles;
	int keyhit;

	const char* tlkFileNames[] = {"Castle", "Dwelling", "Keep", "Towne"};

	numFiles = (sizeof(tlkFileNames)) / sizeof(char*);

	while (!done)
	{
		system("cls");

		printf("The files must be in the same directory as this executable!\n");
		printf("I suggest adding the *.tlk files and this executable OUTSIDE the U5 directory!\n\n");

		for(index = 0; index < numFiles; index++)
		{
			printf("%d: Decode %s.tlk\n", index + 1, tlkFileNames[index]);
		}
		printf("%d: Exit\n", numFiles + 1);

		_kbhit();
		keyhit = getch();

		keyhit -= '1';

		if(keyhit >= 0 && keyhit < numFiles)
		{
			decodefile(tlkFileNames[keyhit]);
		}
		else if(keyhit == numFiles)
		{
			done = true;
		}
	}
	return 0;
}